#ifndef ZW_AUTOREMOVEADD_FSM_H_
#define ZW_AUTOREMOVEADD_FSM_H_

#include <stdint.h>
#include <stdbool.h>
#include <string.h>
#include "zw_serialapi/zw_serialapi.h"
#include "zw_serialapi/zw_classcmd.h"
#include "config.h"

#include "serialAPI.h"
#include "utils.h"
#include "ZW_TransportSecurity.h"

#define NO_ACTION_NETWORK    0   /* User Press Open Network */
#define OPEN_NETWORK    1   /* User Press Open Network */
#define CLOSE_NETWORK   2   /* User Press Close Network */
//States
typedef enum AUTOREMOVEADD_FSM_STATES 
{
    ST_AUTOADD_IDLE = 0,

    ST_WAITING_REMOVE_READY_ACK,
    ST_WAITING_REMOVE_FOUND_ACK,
    ST_WAITING_REMOVING_ACK,
    ST_WAITING_REMOVE_DONE_ACK,
    ST_WAITING_REMOVE_FAILED_ACK,//5

    ST_WAITING_ADD_READY_ACK,
    ST_WAITING_ADD_FOUND_ACK,
    ST_WAITING_ADDING_ACK,
    ST_WAITING_ADD_PROTOCOL_ACK,//adding-->add done
    ST_WAITING_ADD_DONE_ACK,//10
    ST_WAITING_ADD_FAIL_ACK,

    ST_INTERVIEWING_DEVICE,

    ST_WAITING_OPEN_NETWORK,
    ST_WAITING_REMOVE_TO_ADD,
    ST_WAITING_CLOSE_ADD,//15
    ST_WAITING_FINISH_REMOVE,
    ST_WAITING_FINISH_ADD,
    ST_WAITING_INTERVIEW_TO_OPEN,
    ST_WAITING_FINISH_INTERVIEW,
    ST_WAITING_ADD_SECURE,

}AUTOREMOVEADD_FSM_STATES_T;

//Events
typedef enum AUTOREMOVEADD_FSM_EV
{
    EV_OPEN_NETWORK = 0,
    EV_ADD_NEW_DEVICE,
    EV_REMOVE_NODE_READY_OK,
    EV_REMOVE_NODE_FOUND_OK,
    EV_REMOVING_ACK,//DONE
    EV_REMOVE_DONE_ACK,//DONE
    EV_REMOVE_FAIL_ACK,//FAIL    5
    //EV_REMOVING_NAK,//FAIL

    EV_ADD_READY_OK,
    EV_ADD_FOUND_OK,
    EV_ADD_DONE_ACK,
    EV_ADD_FAIL_ACK,//10
    EV_ADD_PROTOCOL_OK,
    EV_ADDING_ACK,
    //EV_ADDING_NAK,

    EV_FINISH_INTERVIEW,
    EV_CLOSE_NETWORK,//15

    EV_TIMEOUT_ADD_READY,
    EV_TIMEOUT_CHANGE_REMOVE_TO_ADD,
    EV_TIMEOUT_WAITING_CLOSE_ADD_READY,//CHANGE TO REMOVE READY BY EVENT OPEN NETWORK
    EV_TIMEOUT_WAITING_OPEN_NETWORK,
    EV_TIMEOUT_WAITING_ADDING,
    EV_TIMEOUT_WAIT_INTERVIEW_TO_OPEN,
    EV_CLOSE_NETWORK_AT_INTERVIEW,
    EV_OPEN_NETWORK_AT_INTERVIEW,
    EV_FINISH_ADD_SECURITY,
    EV_CLOSE_NWK_AT_ADDING,
    NO_ACTION_FROM_HANDLER,
    

}AUTOREMOVEADD_FSM_EV_T;

void PostEventAutoRemoveAdd(AUTOREMOVEADD_FSM_EV_T ev);
AUTOREMOVEADD_FSM_STATES_T GetAutoAddFsmState(void);
extern void SecurityInclusionDone_Compl(uint8_t bStatus, uint8_t bSource, uint8_t *pCmd, uint8_t bLen);

#define STATE_AUTO_REMOVE_ADD enum AUTOREMOVEADD_FSM_STATES
void ChangeTimeoutOfState(uint8_t state, uint32_t newTimeout);
#endif /* ZW_ADDINGINTERVIEWDEVICE_FSM_H_ */
